part of 'generated.dart';

class ListShiftRolesByBusinessDateRangeCompletedOrdersVariablesBuilder {
  String businessId;
  Timestamp start;
  Timestamp end;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  ListShiftRolesByBusinessDateRangeCompletedOrdersVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  ListShiftRolesByBusinessDateRangeCompletedOrdersVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersVariablesBuilder(this._dataConnect, {required  this.businessId,required  this.start,required  this.end,});
  Deserializer<ListShiftRolesByBusinessDateRangeCompletedOrdersData> dataDeserializer = (dynamic json)  => ListShiftRolesByBusinessDateRangeCompletedOrdersData.fromJson(jsonDecode(json));
  Serializer<ListShiftRolesByBusinessDateRangeCompletedOrdersVariables> varsSerializer = (ListShiftRolesByBusinessDateRangeCompletedOrdersVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<ListShiftRolesByBusinessDateRangeCompletedOrdersData, ListShiftRolesByBusinessDateRangeCompletedOrdersVariables>> execute() {
    return ref().execute();
  }

  QueryRef<ListShiftRolesByBusinessDateRangeCompletedOrdersData, ListShiftRolesByBusinessDateRangeCompletedOrdersVariables> ref() {
    ListShiftRolesByBusinessDateRangeCompletedOrdersVariables vars= ListShiftRolesByBusinessDateRangeCompletedOrdersVariables(businessId: businessId,start: start,end: end,offset: _offset,limit: _limit,);
    return _dataConnect.query("listShiftRolesByBusinessDateRangeCompletedOrders", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles {
  final String shiftId;
  final String roleId;
  final int count;
  final int? assigned;
  final double? hours;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? totalValue;
  final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole role;
  final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift shift;
  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles.fromJson(dynamic json):
  
  shiftId = nativeFromJson<String>(json['shiftId']),
  roleId = nativeFromJson<String>(json['roleId']),
  count = nativeFromJson<int>(json['count']),
  assigned = json['assigned'] == null ? null : nativeFromJson<int>(json['assigned']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole.fromJson(json['role']),
  shift = ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift.fromJson(json['shift']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles;
    return shiftId == otherTyped.shiftId && 
    roleId == otherTyped.roleId && 
    count == otherTyped.count && 
    assigned == otherTyped.assigned && 
    hours == otherTyped.hours && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role && 
    shift == otherTyped.shift;
    
  }
  @override
  int get hashCode => Object.hashAll([shiftId.hashCode, roleId.hashCode, count.hashCode, assigned.hashCode, hours.hashCode, startTime.hashCode, endTime.hashCode, totalValue.hashCode, role.hashCode, shift.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['roleId'] = nativeToJson<String>(roleId);
    json['count'] = nativeToJson<int>(count);
    if (assigned != null) {
      json['assigned'] = nativeToJson<int?>(assigned);
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    json['shift'] = shift.toJson();
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles({
    required this.shiftId,
    required this.roleId,
    required this.count,
    this.assigned,
    this.hours,
    this.startTime,
    this.endTime,
    this.totalValue,
    required this.role,
    required this.shift,
  });
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole {
  final String id;
  final String name;
  final double costPerHour;
  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift {
  final String id;
  final Timestamp? date;
  final String? location;
  final String? locationAddress;
  final String title;
  final EnumValue<ShiftStatus>? status;
  final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder order;
  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  locationAddress = json['locationAddress'] == null ? null : nativeFromJson<String>(json['locationAddress']),
  title = nativeFromJson<String>(json['title']),
  status = json['status'] == null ? null : shiftStatusDeserializer(json['status']),
  order = ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift;
    return id == otherTyped.id && 
    date == otherTyped.date && 
    location == otherTyped.location && 
    locationAddress == otherTyped.locationAddress && 
    title == otherTyped.title && 
    status == otherTyped.status && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, date.hashCode, location.hashCode, locationAddress.hashCode, title.hashCode, status.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    if (locationAddress != null) {
      json['locationAddress'] = nativeToJson<String?>(locationAddress);
    }
    json['title'] = nativeToJson<String>(title);
    if (status != null) {
      json['status'] = 
    shiftStatusSerializer(status!)
    ;
    }
    json['order'] = order.toJson();
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShift({
    required this.id,
    this.date,
    this.location,
    this.locationAddress,
    required this.title,
    this.status,
    required this.order,
  });
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder {
  final String id;
  final EnumValue<OrderType> orderType;
  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  orderType = orderTypeDeserializer(json['orderType']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder;
    return id == otherTyped.id && 
    orderType == otherTyped.orderType;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, orderType.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['orderType'] = 
    orderTypeSerializer(orderType)
    ;
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRolesShiftOrder({
    required this.id,
    required this.orderType,
  });
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersData {
  final List<ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles> shiftRoles;
  ListShiftRolesByBusinessDateRangeCompletedOrdersData.fromJson(dynamic json):
  
  shiftRoles = (json['shiftRoles'] as List<dynamic>)
        .map((e) => ListShiftRolesByBusinessDateRangeCompletedOrdersShiftRoles.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersData otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersData;
    return shiftRoles == otherTyped.shiftRoles;
    
  }
  @override
  int get hashCode => shiftRoles.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['shiftRoles'] = shiftRoles.map((e) => e.toJson()).toList();
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersData({
    required this.shiftRoles,
  });
}

@immutable
class ListShiftRolesByBusinessDateRangeCompletedOrdersVariables {
  final String businessId;
  final Timestamp start;
  final Timestamp end;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  ListShiftRolesByBusinessDateRangeCompletedOrdersVariables.fromJson(Map<String, dynamic> json):
  
  businessId = nativeFromJson<String>(json['businessId']),
  start = Timestamp.fromJson(json['start']),
  end = Timestamp.fromJson(json['end']) {
  
  
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListShiftRolesByBusinessDateRangeCompletedOrdersVariables otherTyped = other as ListShiftRolesByBusinessDateRangeCompletedOrdersVariables;
    return businessId == otherTyped.businessId && 
    start == otherTyped.start && 
    end == otherTyped.end && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([businessId.hashCode, start.hashCode, end.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['businessId'] = nativeToJson<String>(businessId);
    json['start'] = start.toJson();
    json['end'] = end.toJson();
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  ListShiftRolesByBusinessDateRangeCompletedOrdersVariables({
    required this.businessId,
    required this.start,
    required this.end,
    required this.offset,
    required this.limit,
  });
}

